knex = require 'knex'
Bookshelf = require 'bookshelf'
Fields = require './src/bookshelf-fields'

db = Bookshelf knex
    client: 'sqlite'
    debug: false
    connection:
        filename: ':memory:'

db.plugin Fields.plugin()
db.plugin require 'bookshelf-coffee-helpers'
db.pollute_function_prototype()

db.knex.schema.createTable 'users', (t) ->
    t.increments 'id'
    t.string 'email'
.then ->
    class User extends db.Model
        tableName: 'users'
        idAttribute: 'id'

        @validate_uniq_email: (value) ->
            User.forge(email: value).fetch().then (res) -> res is null

        @enable_validation()
        @field Fields.EmailField, 'email', validations: [ User.validate_uniq_email ]

    User.forge(email: 'test@test.com').save().then ->
        console.log 'inserted first time'
        User.forge(email: 'test@test.com').validate()
            .then ->
                console.log 'inserted second time'
            .catch (e) ->
                console.log e.toJSON()

    .catch (e) -> console.log e.toJSON()
    .finally -> process.exit()
